// gpibout.cpp
#include <iostream.h>
#include <stdlib.h>
#include "gpibio.h"

// OUTPUT CLASS FUNCTIONS
gpibout::gpibout(int d,int b) : gpibio(b)  // constructor
{
   device = dvr[b]->open_device(d);
}

// gout << string
gpibout & gpibout::operator <<(char _FAR *s)
{
    sput(s);
    return (*this);
}

// gout << char
gpibout & gpibout::operator <<(char _c)
{
   sputc(_c);
   return *this;
}

// gout << long
gpibout & gpibout::operator <<(long _l)
{
   char string[33];

   // Convert and output numeric string   
   return *this << ltoa(_l,string,radix);
}

// gout << short
gpibout & gpibout::operator <<(short _s)
{
    return *this << (long)_s;
}

// gout << int
gpibout & gpibout::operator <<(int _i)
{
    return *this << (long)_i;
}

// gout << double
gpibout & gpibout::operator <<(double _d)
{
    char string[32];

    // Convert and output double
    return *this << gcvt(_d,5,string);
}

// gout << float
gpibout & gpibout::operator <<(float _f)
{
    return *this << (double)_f;
}

// gout << manipulator
gpibout & gpibout::operator<< (gpibout & (*_f)(gpibout &))
{
    return _f(*this);
}

// Dummy underflow functions

int gpibout::underflow()
{
   return 0;
}

// Overflow function  -- flush buffer and make more room
void gpibout::overflow()
{
   // See if we have an output buffer first
   if(pbase_)
   {
      ::ibwrt(device,pbase_,(int)(pptr_-pbase_));
      status = ibsta;              // get write status
   }
   else
   {
      pbase_ = new char[128];
      if(pbase_ == NULL)
      {
         cerr << "Can't allocate Output Stream Buffer." << endl;
         exit(1);
      }
      epptr_ = pbase_ + 128;
      status = 0;
   }
   pptr_ = pbase_;
}

