// manip.cpp
#include "gpibio.h"

// Output flush
gpibout & flush(gpibout &x)
{
   x.overflow();
   return(x);
}

// Output endl
gpibout & endl(gpibout &x)
{
    x.sputc('\n');
    flush(x);
    return(x);
}

// Output base 10
gpibout & dec(gpibout &x)
{
    x.radix = 10;
    return(x);
}

// Output base 16
gpibout & hex(gpibout &x)
{
    x.radix = 16;
    return(x);
}

// Output base 8
gpibout & oct(gpibout &x)
{
    x.radix = 8;
    return(x);
}

// Output base 2
gpibout & bin(gpibout &x)
{
    x.radix = 2;
    return(x);
}
// Input base 10
gpibin & dec(gpibin &x)
{
    x.radix = 10;
    return(x);
}

// Input base 16
gpibin & hex(gpibin &x)
{
    x.radix = 16;
    return(x);
}

// Input base 8
gpibin & oct(gpibin &x)
{
    x.radix = 8;
    return(x);
}

// Input Base 2
gpibin & bin(gpibin &x)
{
    x.radix = 2;
    return(x);
}

// Input Flush -- Throw away rest of input stream
gpibin & flush(gpibin &x)
{
   x.flush_input();
   return(x);
}
